SystemOrganization addCategory: #'iCook-Model'!
SystemOrganization addCategory: #'iCook-View'!
SystemOrganization addCategory: #'iCook-Tests'!

TwitterBootstrapFileLibrary subclass: #ICookLibrary
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iCook-View'!

!ICookLibrary class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/1/2012 13:57'!
applicationName
	^ 'iCook'! !

WAComponent subclass: #ICookComponent
	instanceVariableNames: 'recipeList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iCook-View'!

!ICookComponent class methodsFor: 'testing' stamp: 'NicolasVanderAuwera 9/30/2012 18:01'!
canBeRoot
	^ true! !

!ICookComponent class methodsFor: 'class initialization' stamp: 'NicolasVanderAuwera 10/1/2012 07:12'!
initialize
	super initialize.
	WAAdmin register: self asApplicationAt: 'icook'! !

!ICookComponent methodsFor: 'adding' stamp: 'NicolasVanderAuwera 10/1/2012 15:12'!
addCss: anHtmlRoot
	anHtmlRoot stylesheet url: self fileLibrary / #bootstrapCss.
	anHtmlRoot stylesheet url: self fileLibrary / #docsCss.
	anHtmlRoot stylesheet url: self fileLibrary / #prettifyCss! !

!ICookComponent methodsFor: 'adding' stamp: 'NicolasVanderAuwera 10/1/2012 15:12'!
addFavicons: aRoot
	aRoot link
		beShortcutIcon;
		url: self fileLibrary / #faviconIco.
	aRoot link
		relationship: 'apple-touch-icon';
		url: self fileLibrary / #appletouchiconPng.
	aRoot link
		relationship: 'apple-touch-icon';
		url: self fileLibrary / #appletouchicon72x72Png.
	aRoot link
		relationship: 'apple-touch-icon';
		url: self fileLibrary / #appletouchicon114x114Png! !

!ICookComponent methodsFor: 'adding' stamp: 'NicolasVanderAuwera 10/1/2012 15:13'!
addJs: anHtmlRoot
	self html5ShimForIE: anHtmlRoot! !

!ICookComponent methodsFor: 'adding' stamp: 'NicolasVanderAuwera 10/1/2012 15:14'!
addMetaTags: anHtmlRoot
	anHtmlRoot meta charset: 'utf-8'.
	anHtmlRoot title: 'iCook'.
	anHtmlRoot meta
		contentScriptType: '';
		name: 'My list of recipes.'.
	anHtmlRoot meta
		contentScriptType: '';
		name: 'Nicolas Vander Auwera'! !

!ICookComponent methodsFor: 'hooks' stamp: 'NicolasVanderAuwera 10/1/2012 07:37'!
children
	^ Array with: recipeList! !

!ICookComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/1/2012 15:12'!
fileLibrary
	^ ICookLibrary! !

!ICookComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/1/2012 15:14'!
html5ShimForIE: aRoot
	aRoot if
		lessThan;
		ie9;
		do: [ aRoot script url: '//html5shim.googlecode.com/svn/trunk/html5.js' ]! !

!ICookComponent methodsFor: 'initialization' stamp: 'NicolasVanderAuwera 10/1/2012 10:32'!
initialize
	super initialize.
	recipeList := RecipeListComponent new! !

!ICookComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/1/2012 15:17'!
renderContentOn: html
	html div class: 'container-fluid'; with: [
		self renderTitleOn: html.
		html render: recipeList ]! !

!ICookComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/1/2012 08:37'!
renderTitleOn: html
	html heading level1; with: self title! !

!ICookComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/1/2012 13:57'!
title
	^ ICookLibrary applicationName! !

!ICookComponent methodsFor: 'updating' stamp: 'NicolasVanderAuwera 10/1/2012 15:10'!
updateRoot: anHtmlRoot
	super updateRoot: anHtmlRoot.
	anHtmlRoot beHtml5.
	self addMetaTags: anHtmlRoot.
	self addCss: anHtmlRoot.
	self addJs: anHtmlRoot.
	self addFavicons: anHtmlRoot! !

WAComponent subclass: #RecipeComponent
	instanceVariableNames: 'recipe'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iCook-View'!

!RecipeComponent class methodsFor: 'instance creation' stamp: 'NicolasVanderAuwera 10/1/2012 10:44'!
recipe: aRecipe
	^ self new recipe: aRecipe! !

!RecipeComponent methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/1/2012 10:44'!
recipe: aRecipe
	recipe := aRecipe! !

!RecipeComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/1/2012 10:43'!
renderContentOn: html
	html article
		class: 'recipe';
		with: [ self renderRecipeOn: html ]! !

!RecipeComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/1/2012 12:51'!
renderImageOn: html
	recipe hasImage
		ifTrue: [ 
			html image
				altText: recipe image filename;
				url: recipe image url ]! !

!RecipeComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/1/2012 11:04'!
renderIngredient: aIngredient on: html
	html
		listItem: [ 
			html
				text: aIngredient amount;
				text: ' ';
				text: aIngredient unit;
				text: ' ';
				text: aIngredient name ]! !

!RecipeComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/1/2012 12:30'!
renderIngredientsOn: html
	html heading level2; with: 'Ingredients'.
	html unorderedList: [ recipe ingredients do: [ :aIngredient | self renderIngredient: aIngredient on: html ] ]! !

!RecipeComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/1/2012 13:55'!
renderRatingOn: html
	html div
		class: 'rating';
		with: recipe printRating! !

!RecipeComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/1/2012 12:50'!
renderRecipeOn: html
	self renderImageOn: html.
	html heading: recipe title.
	self renderRatingOn: html.
	self renderTextOn: html.
	self renderIngredientsOn: html.
	self renderStepsOn: html! !

!RecipeComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/1/2012 12:20'!
renderStepsOn: html
	html orderedList: [ recipe steps do: [ :aStep | html listItem: aStep description ] ]! !

!RecipeComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/1/2012 12:31'!
renderTextOn: html
	html heading level2; with: 'Description'.
	html paragraph: recipe text! !

WAComponent subclass: #RecipeListComponent
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iCook-View'!

!RecipeListComponent methodsFor: 'actions' stamp: 'NicolasVanderAuwera 10/1/2012 14:02'!
addRecipe
	| recipe |
	recipe := self call: Recipe buildComponent.
	recipe ifNotNil: [ :arg | Recipe add: recipe ]! !

!RecipeListComponent methodsFor: 'actions' stamp: 'NicolasVanderAuwera 10/1/2012 08:33'!
editRecipe: aRecipe
	self call: aRecipe asComponent addValidatedForm! !

!RecipeListComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/1/2012 08:17'!
removeRecipe: aRecipe
	(self confirm: 'Are you sure that you want to remove this recipe?')
		ifTrue: [ Recipe remove: aRecipe ]! !

!RecipeListComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/1/2012 07:34'!
renderContentOn: html
	html unorderedList: [ Recipe recipes do: [ :recipe | html listItem: [ self renderRecipe: recipe on: html ] ] ].
	html anchor
        callback: [ self addRecipe ];
        with: 'Add recipe'.! !

!RecipeListComponent methodsFor: 'rendering' stamp: 'NicolasVanderAuwera 10/1/2012 10:53'!
renderRecipe: aRecipe on: html
	html text: aRecipe title.
	html text: ' ('.
	html anchor
		callback: [ self viewRecipe: aRecipe ];
		with: 'view'.
	html text: ' | '.
	html anchor
		callback: [ self editRecipe: aRecipe ];
		with: 'edit'.
	html text: ' | '.
	html anchor
		callback: [ self removeRecipe: aRecipe ];
		with: 'remove'.
	html text: ')'! !

!RecipeListComponent methodsFor: 'actions' stamp: 'NicolasVanderAuwera 10/1/2012 10:54'!
viewRecipe: aRecipe
	self call: (RecipeComponent recipe: aRecipe)! !

Object subclass: #Entry
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iCook-Model'!

!Entry methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/1/2012 11:46'!
descriptionContainer
	^ super descriptionContainer
		componentRenderer: MACssRenderer;
		yourself! !

Entry subclass: #Ingredient
	instanceVariableNames: 'name amount unit'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iCook-Model'!

!Ingredient methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 9/30/2012 18:10'!
amount
	^ amount! !

!Ingredient methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 9/30/2012 18:10'!
amount: anObject
	amount := anObject! !

!Ingredient methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/1/2012 11:45'!
descriptionAmount
	<magritteDescription>
	^ MANumberDescription new
		accessor: #amount;
		label: 'Amount';
		priority: 2;
		bePositive;
		yourself! !

!Ingredient methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/1/2012 09:23'!
descriptionName
	<magritteDescription>
	^ MAStringDescription new
		accessor: #name;
		label: 'Name';
		priority: 1;
		beRequired;
		yourself! !

!Ingredient methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/1/2012 11:01'!
descriptionUnit
	<magritteDescription>
	^ MASingleOptionDescription new
		accessor: #unit;
		label: 'Unit';
		options: #('kg' 'g' 'mg' 'l' 'cl' 'ml' 'teaspoon' 'tablespoon');
		priority: 3;
		yourself! !

!Ingredient methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 9/30/2012 18:10'!
name
	^ name! !

!Ingredient methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 9/30/2012 18:10'!
name: anObject
	name := anObject! !

!Ingredient methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 9/30/2012 18:10'!
unit
	^ unit! !

!Ingredient methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 9/30/2012 18:10'!
unit: anObject
	unit := anObject! !

Entry subclass: #Recipe
	instanceVariableNames: 'title time ingredients steps rating text image difficulty persons'
	classVariableNames: 'Database'
	poolDictionaries: ''
	category: 'iCook-Model'!

!Recipe class methodsFor: 'adding' stamp: 'NicolasVanderAuwera 9/30/2012 19:30'!
add: aRecipe
	self recipes add: aRecipe! !

!Recipe class methodsFor: 'component creation' stamp: 'NicolasVanderAuwera 10/1/2012 09:11'!
buildComponent
	^ self new
		asComponent
		addValidatedForm;
		yourself! !

!Recipe class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/1/2012 14:24'!
maxDifficulty
	^ 3! !

!Recipe class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/1/2012 13:53'!
maxRating
	^ 5! !

!Recipe class methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 9/30/2012 19:30'!
recipes
	Database ifNil: [ Database := OrderedCollection new ].
	^ Database! !

!Recipe class methodsFor: 'removing' stamp: 'NicolasVanderAuwera 9/30/2012 19:31'!
remove: aRecipe
	self recipes remove: aRecipe! !

!Recipe methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/1/2012 14:24'!
descriptionDifficulty
	<magritteDescription>
	^ MASingleOptionDescription new
		options: (1 to: self class maxDifficulty);
		accessor: #difficulty;
		label: 'Difficulty';
		priority: 8;
		yourself! !

!Recipe methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/1/2012 08:30'!
descriptionImage
	<magritteDescription>
	^ MAFileDescription new
		accessor: #image;
		label: 'Image';
		priority: 4;
		yourself! !

!Recipe methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/1/2012 14:23'!
descriptionIngredients
	<magritteDescription>
	^ MAToManyRelationDescription new
		accessor: #ingredients;
		label: 'Ingredients';
		classes: (Array with: Ingredient);
		addCondition: [ :value | value notEmpty ] labelled: 'Your recipe must contain at least one ingredient.';
		priority: 6;
		yourself! !

!Recipe methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/1/2012 14:25'!
descriptionPersons
	<magritteDescription>
	^ MANumberDescription new
		accessor: #persons;
		label: 'Persons';
		priority: 9;
		bePositive;
		yourself! !

!Recipe methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/1/2012 13:53'!
descriptionRating
	<magritteDescription>
	^ MASingleOptionDescription new
		options: (1 to: self class maxRating);
		accessor: #rating;
		label: 'Rating';
		priority: 2;
		yourself! !

!Recipe methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/1/2012 14:23'!
descriptionSteps
	<magritteDescription>
	^ MAToManyRelationDescription new
		accessor: #steps;
		label: 'Steps';
		classes: (Array with: Step);
		addCondition: [ :value | value notEmpty ] labelled: 'Your recipe must contain at least one step.';
		priority: 5;
		beSorted;
		yourself! !

!Recipe methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/1/2012 08:12'!
descriptionText
	<magritteDescription>
	^ MAMemoDescription new
		accessor: #text;
		label: 'Description';
		priority: 3;
		yourself! !

!Recipe methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/1/2012 14:20'!
descriptionTime
	<magritteDescription>
	^ MATimeDescription new
		accessor: #time;
		label: 'Time';
		priority: 7;
		yourself! !

!Recipe methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/1/2012 08:29'!
descriptionTitle
	<magritteDescription>
	^ MAStringDescription new
		accessor: #title;
		label: 'Title';
		priority: 1;
		beRequired;
		yourself! !

!Recipe methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/1/2012 14:24'!
difficulty
	^ difficulty! !

!Recipe methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/1/2012 14:24'!
difficulty: anObject
	difficulty := anObject! !

!Recipe methodsFor: 'testing' stamp: 'NicolasVanderAuwera 10/1/2012 10:55'!
hasImage
	^ image notNil! !

!Recipe methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/1/2012 08:29'!
image
	^ image! !

!Recipe methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/1/2012 08:29'!
image: anObject
	image := anObject! !

!Recipe methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/1/2012 10:03'!
ingredients
	^ ingredients! !

!Recipe methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/1/2012 07:58'!
ingredients: anObject
	ingredients := anObject! !

!Recipe methodsFor: 'initialize-release' stamp: 'NicolasVanderAuwera 10/1/2012 14:03'!
initialize
	ingredients := OrderedCollection new.
	steps := OrderedCollection new! !

!Recipe methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/1/2012 14:26'!
persons
	^ persons! !

!Recipe methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/1/2012 14:26'!
persons: anObject
	persons := anObject! !

!Recipe methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/1/2012 13:55'!
printRating
	^ rating greaseString , ' on ' , self class maxRating greaseString! !

!Recipe methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/1/2012 07:58'!
rating
	^ rating! !

!Recipe methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/1/2012 07:58'!
rating: anObject
	rating := anObject! !

!Recipe methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/1/2012 12:17'!
steps
	^ steps! !

!Recipe methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/1/2012 11:40'!
steps: anObject
	steps := anObject! !

!Recipe methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/1/2012 07:58'!
text
	^ text! !

!Recipe methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/1/2012 07:58'!
text: anObject
	text := anObject! !

!Recipe methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/1/2012 14:17'!
time
	^ time! !

!Recipe methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/1/2012 14:17'!
time: anObject
	time := anObject! !

!Recipe methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/1/2012 07:58'!
title
	^ title! !

!Recipe methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 10/1/2012 08:31'!
title: aString
	title := aString! !

Entry subclass: #Step
	instanceVariableNames: 'description'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'iCook-Model'!

!Step methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 9/30/2012 18:12'!
description
	^ description! !

!Step methodsFor: 'accessing' stamp: 'NicolasVanderAuwera 9/30/2012 18:12'!
description: anObject
	description := anObject! !

!Step methodsFor: 'descriptions' stamp: 'NicolasVanderAuwera 10/1/2012 11:54'!
descriptionDescription
	<magritteDescription>
	^ MAMemoDescription new
		accessor: #description;
		label: 'Description';
		priority: 2;
		beRequired;
		yourself! !
ICookComponent initialize!
